#include "closing.h"
#include "hardware.h"
#include "statemodel.h" // For the other states

void
setup_closing()
{
  closing = default_state;
  closing.closed_detected = closed_detected;
  closing.open_button_pressed = open_button_pressed;
  closing.entry_to = entry_to;
}


static state* 
closed_detected()
{
  set_motor(MOTOR_OFF);
  return &closed;
}

static state* 
open_button_pressed()
{
  return &opening;
}

static void 
entry_to()
{
  set_motor(MOTOR_CLOSING);
}
