#include "opening.h"
#include "hardware.h"
#include "statemodel.h"  // For the other states

#include <stdio.h>

void
setup_opening()
{
  opening = default_state;
  opening.close_button_pressed = close_button_pressed;
  opening.opened_detected      = opened_detected;
  opening.entry_to = entry_to;
}


static state* 
close_button_pressed()
{
  return &closing;
}

static state* 
opened_detected()
{
  set_motor(MOTOR_OFF);
  return &opened;
}

static void 
entry_to()
{
  set_motor(MOTOR_OPENING);
}
