#ifndef state_h
#define state_h

// Add an alias for a type to the global name space.
//      |-  type  -| |- alias -|
typedef struct state    state; 

// Add an alias for event handlers.
//      |- return type-| |- alias   -||- params -|
typedef      state*         event_handler(void);
 
// Add an alias for actions.
typedef      void        action(void);

// Define the identifier state as a struct.
struct state {
  event_handler*  close_button_pressed;
  event_handler*  closed_detected;
  event_handler*  open_button_pressed;
  event_handler*  opened_detected;
  action*         entry_to;
  action*         exit_from;
};

// Declare variables to hold pointers to the default event handler and
// the default action. They are extern because they are used in each
// of the individual state files but defined in state.c.
extern event_handler* default_event_handler;
extern action* default_action;

// Declare a variable to hold the default state. It is extern because it
// is used in each of the individual state files but defined in state.c
extern struct state default_state;

#endif
