#ifndef STATEMODEL_H
#define STATEMODEL_H

#include "hardware.h"
#include "state.h"


// Declare all of the states used in the state model.
// They are extern because they are defined (i.e., the  memory is 
// actually allocated) elsewhere (i.e., in the header files for the 
// individual states).

extern state closed;
extern state closing;
extern state opened;
extern state opening;

// Declare all of the global setup functions for the individual states.
void
setup_closed();

void
setup_closing();

void
setup_opened();

void
setup_opening();



// Declare all of the functions used in the state model itself (i.e.,
// not in the individual states).

void
setup_states();

void
handle_event(event current_event);


#endif
